EDIT - bug #9405
task # 4338 (In Progress): [MASTER] Handle abbreviated title and protected cache correctly in TaxEditor

Fields set to irrelevant for cache should be set by state only
01/20/2021 06:02 PM - Andreas Mller

Status: Closed Start date:

Priority: Highest Due date:

Assignee: Andreas Mller % Done: 100%
Category: taxeditor Estimated time: 0:00 hour
Target version: Release 5.19

Severity: normal Found in Version:

Description

follow up from #3737

Currently this is not yet the case as they are set during Ul update by calling refresh only on certain fields and depending on the place
in code where the update was triggered.

Related issues:

Related to EDIT - bug #4944: "Protected" indication for references needs to b... Closed
Related to EDIT - bug #4915: Abbrev title for person should never be orange Closed
Copied from EDIT - bug #3737: Protected caches for taxa and names behave inco... Closed
Copied to EDIT - feature request #9417: Advanced issues for cache relevance h... New

Associated revisions

Revision 202edbff - 01/23/2021 02:08 AM - Andreas Muller

ref #9405 , ref #4944 refactor the cache protection indication handling in TaxEditor details view elements

Revision c3b6d097 - 01/25/2021 02:25 PM - Andreas Miuiller
ref #9405 , ref #4944 fix NPE in CacheRelevanceHelper

Revision 5014c22f - 03/07/2021 11:25 PM - Andreas Miiller
ref #9405, ref #4944 adapt colors for cache protected fields a bit

History

#1 - 01/20/2021 06:03 PM - Andreas Miuller

- Copied from bug #3737: Protected caches for taxa and names behave inconsistent added

#2 - 01/20/2021 06:04 PM - Andreas Miuiller
- Subject changed from Fields set to irrelevant should be set by state only to Fields set to irrelevant for cache should be set by state only

- Status changed from New to In Progress

#3 - 01/20/2021 06:06 PM - Andreas Miiller

- Related to bug #4944: "Protected" indication for references needs to be improved added

#4 - 01/23/2021 02:19 AM - Andreas Miiller

This is mostly fixed. Some advanced features stay:

e trigger updateCacheRelevance() with ToggledText state change listener (probably this is the SelectionListener)

improve handling of team members in Team element. (by setting a breakpoint somewhere at TeamMemberElement creation it becomes clearer
how to insert registration

improve colors

handle also for other DetailElements like Collection detail element

improve use of ICacheRelevantFormElement in class hierarchies (probably the use can still be reduced)

implement RefType dependency (mostly of abbrevTitleCache) in ReferenceDetail view (also depending on cache strategy)

Very advanced: use cache strategy to define which fields are relevant
#5 - 01/23/2021 02:21 AM - Andreas Miiller

- Copied to feature request #9417: Advanced issues for cache relevance handling added

#6 - 01/23/2021 02:23 AM - Andreas Miiller

- Status changed from In Progress to Resolved

- Assignee changed from Andreas Muiller to Katja Luther

- % Done changed from 0 to 50

This should be fixed. | moved advanced issues to new ticket #9417. Please review.

This is also related to #4944. Please include this in review.

#7 - 01/23/2021 02:26 AM - Andreas Miiller
- Related to bug #4915: Abbrev title for person should never be orange added

#8 - 01/23/2021 02:39 AM - Andreas Miiller

The general idea of the refactoring is:

in a first step all elements which are relevant for a cache get do register the cache the depend on.

when the caches change the updateCacheRelevance() method is triggered for all such elements (this is currently still done with a cascading call,
but better we should use a state change listener on the toggle/cache field (#9417) in future to make it all still more state dependend.

each cache field has a registered color (CacheRelevance), so if 2 different cache fields exist, it can be indicated by color for which cache the
field is irrelevant (or for both with 3rd color)

fields only indirectly irrelevant (e.g. uninomial for an unprotected namecache but a protected titleCache) use a light color

as the relevant elements and sections do not all inherit from the same base classes a helper class CacheRelevanceHelper exists which handled
typical method calls (decorator pattern)

#9 - 01/26/2021 02:25 PM - Katja Luther

- Status changed from Resolved to Closed

- Assignee changed from Katja Luther to Andreas Mdiller

This seems to work correctly (also for references), | only added the colouring of the date field for references to #9417.

#10

- 01/26/2021 02:25 PM - Katja Luther

- % Done changed from 50 to 100
